Arch MeshToShape/en: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
 
Line 22: Line 22:
==Description==
==Description==


[[Arch_MeshToShape|Arch MeshToShape]] converts a selected [[Mesh|Mesh]] ([[Mesh_Feature|Mesh Feature]]) object into a [[Shape|Shape]] ([[Part_Feature|Part Feature]]) object.
The '''Arch MeshToShape''' tool converts a selected [[Mesh|Mesh]] ([[Mesh_Feature|Mesh Feature]]) object into a [[Shape|Shape]] ([[Part_Feature|Part Feature]]) object.


This tool is optimized for objects with flat faces (no curves). The corresponding tool {{Button|[[File:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|Part ShapeFromMesh]]}} from the [[Image:Workbench_Part.svg|16px]] [[Part_Workbench|Part Workbench]] might be more suited for objects that contain curved surfaces.
This tool is optimized for objects with flat faces (no curves). The corresponding tool {{Button|[[File:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|Part ShapeFromMesh]]}} from the [[Image:Workbench_Part.svg|16px]] [[Part_Workbench|Part Workbench]] might be more suited for objects that contain curved surfaces.
Line 40: Line 40:


This tool can be used in [[Macros|macros]] and from the [[Python|Python]] console by using the following function:
This tool can be used in [[Macros|macros]] and from the [[Python|Python]] console by using the following function:

{{Code|code=
{{Code|code=
new_obj = meshToShape(obj, mark=True, fast=True, tol=0.001, flat=False, cut=True)
new_obj = meshToShape(obj, mark=True, fast=True, tol=0.001, flat=False, cut=True)
Line 52: Line 53:


Example:
Example:

{{Code|code=
{{Code|code=
import Arch, Mesh, BuildRegularGeoms
import Arch, Mesh, BuildRegularGeoms

Latest revision as of 07:32, 13 June 2024

THIS COMMAND IS PART OF THE INTEGRATED BIM WORKBENCH IN V1.0
This page has been updated for that version.

Arch MeshToShape

Menu location
Utils → Mesh to Shape
Workbenches
BIM
Default shortcut
None
Introduced in version
-
See also
Arch SplitMesh, Arch RemoveShape

Description

The Arch MeshToShape tool converts a selected Mesh (Mesh Feature) object into a Shape (Part Feature) object.

This tool is optimized for objects with flat faces (no curves). The corresponding tool Part ShapeFromMesh from the Part Workbench might be more suited for objects that contain curved surfaces.

Usage

  1. Select a mesh object.
  2. Select the Utils → Mesh to Shape option from the menu.

Properties

Limitations

Scripting

See also: Arch API and FreeCAD Scripting Basics.

This tool can be used in macros and from the Python console by using the following function:

new_obj = meshToShape(obj, mark=True, fast=True, tol=0.001, flat=False, cut=True)

The above code snippet converts the given obj (a mesh), into a shape, joining coplanar facets.

  • If mark is True, non-solid objects will be marked in red.
  • If fast is True, it uses a faster algorithm by building a shell from the facets then removing splitter.
  • tol is the tolerance used when converting mesh segments to wires.
  • If flat is True, it will force the wires to be perfectly planar to be sure they can be converted into faces, but this might leave gaps in the final shell.
  • If cut is True, holes in faces are made by subtraction.

Example:

import Arch, Mesh, BuildRegularGeoms

Box = FreeCAD.ActiveDocument.addObject("Mesh::Cube", "Cube")
Box.Length = 1000
Box.Width = 2000
Box.Height = 1000
FreeCAD.ActiveDocument.recompute()

new_obj = Arch.meshToShape(Box)